org.cpsolver.studentsct.heuristics.selection

## Class CriticalBacktrackSelection

- java.lang.Object
- - org.cpsolver.studentsct.heuristics.selection.BacktrackSelection
  - - org.cpsolver.studentsct.heuristics.selection.CriticalBacktrackSelection

- All Implemented Interfaces:
    NeighbourSelection<Request,Enrollment>, InfoProvider<Request,Enrollment>, SolverListener<Request,Enrollment>

      public class CriticalBacktrackSelection
      extends BacktrackSelection

  Use backtrack neighbour selection. For all unassigned variables (in a random order) that are marked as critical, `RandomizedBacktrackNeighbourSelection` is being used.
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.cpsolver.studentsct.heuristics.selection.BacktrackSelection

      `BacktrackSelection.RequestComparator`

  - ### Field Summary

    - ### Fields inherited from class org.cpsolver.studentsct.heuristics.selection.BacktrackSelection

      `iFailedCounter, iFilter, iIncludeAssignedRequests, iMaxIterations, iNbrIterations, iNbrNoSolution, iNbrRequests, iNbrTimeoutReached, iRBtNSel, iRequestComparator, iRequests, iTotalTime`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CriticalBacktrackSelection(DataProperties properties)`
    `CriticalBacktrackSelection(DataProperties properties, Request.RequestPriority priority)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `init(Solver<Request,Enrollment> solver, String name)`

    - ### Methods inherited from class org.cpsolver.studentsct.heuristics.selection.BacktrackSelection

      `addRequest, getFilter, getInfo, getInfo, init, neighbourFailed, neighbourSelected, nextRequest, selectNeighbour, valueSelected, variableSelected, withFilter`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CriticalBacktrackSelection

          public CriticalBacktrackSelection(DataProperties properties,
                                            Request.RequestPriority priority)

    - #### CriticalBacktrackSelection

          public CriticalBacktrackSelection(DataProperties properties)

  - ### Method Detail

    - #### init

          public void init(Solver<Request,Enrollment> solver,
                           String name)

      Overrides:
        `init` in class `BacktrackSelection`